<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2011 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class tag_graph_block {
  static function get_site_list() {
    return array(
      "tag_graph_site" => t("Tag Graph"));
  }

  static function sort_by_count($tag1, $tag2) {
    return strcasecmp($tag1->count, $tag2->count);
  }

  static function get($block_id, $theme) {
    $block = "";
    switch ($block_id) {
    case "tag_graph_site":
      $options = array();
      foreach (array("tagcolor", "background_color", "mouseover")
               as $option) {
        $value = module::get_var("tag_graph", $option, null);
        if (!empty($value)) {
          switch ($option) {
          case "tagcolor":
            $options["tcolor"] = $value;
            break;
          case "mouseover":
            $options["hicolor"] = $value;
            break;
          case "background_color":
            $options["bgColor"] = $value;
            break;
          }
        }
      }
	 /**
	 * Some sorting of the tags with an admin setting
	 */
	if (module::get_var("tag_graph", "sort_order") == "ALPHA") {
		$tags = tag::popular_tags(9999)->as_array();
		usort($tags, array("tag", "sort_by_name"));
	}
	else if (module::get_var("tag_graph", "sort_order") == "ASCEND") {
		$tags = ORM::factory("tag")->order_by("count", "ASC")->find_all();
	}
	else if (module::get_var("tag_graph", "sort_order") == "DECEND") {
		$tags = ORM::factory("tag")->order_by("count", "DESC")->find_all();	
	}
	  /**
	   * Then pass it to the block:
	   */
	
      $block = new Block();
      $block->css_id = "g-tag";
      $block->title = module::get_var("tag_graph", "title");
      $block->content = new View("tag_graph_block.html");
      $block->content->tags = $tags;
      $block->content->options = $options;

      if ($theme->item() && $theme->page_subtype() != "tag" && access::can("edit", $theme->item())) {
        $controller = new Tags_Controller();
        $block->content->form = tag::get_add_form($theme->item());
      } else {
        $block->content->form = "";
      }
      break;
    }
    return $block;
  }
}
